package geniusweb.protocol.tournament.allpermutationslearn;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

import geniusweb.protocol.session.SessionResult;
import geniusweb.protocol.tournament.allpermutations.AllPermutationsSettings;
import geniusweb.protocol.tournament.allpermutations.AllPermutationsState;

/**
 * A non-parallel simple implementation of all-permutations
 */
public class AllPermutationsLearnState extends AllPermutationsState {

	@JsonCreator
	public AllPermutationsLearnState(
			@JsonProperty("toursettings") AllPermutationsSettings toursettings,
			@JsonProperty("results") List<SessionResult> results) {
		super(toursettings, results);
	}

	/**
	 * 
	 * @param result the next {@link SessionResult}
	 * @return new state
	 * @throws IllegalArgumentException if the result participants are not
	 *                                  matching the expected participants
	 */
	@Override
	public AllPermutationsLearnState with(List<SessionResult> result) {
		ArrayList<SessionResult> newresults = new ArrayList<>(results);
		newresults.addAll(result);
		return new AllPermutationsLearnState(
				(AllPermutationsLearnSettings) toursettings, newresults);
	}

}
